import numpy as np
import matplotlib.pyplot as plt
import matplotlib.colors as colors
from matplotlib import cm
from matplotlib.colors import ListedColormap

import matplotlib
print(matplotlib.__version__)


first=True
folder='angle_matrix_mpi4'

print("reading file...")
f = open(folder, 'r')

j=0
for line in f:
    if first:
        thx=int(float(line.split()[0]))
        Nx=int(float(line.split()[1]))
        Ny=int(float(line.split()[2]))
        shiftx=int(float(line.split()[3]))
        deg_split=int(float(line.split()[4]))
        maxy=int(Ny/(2*deg_split))
        maxx=int(Nx/(2*deg_split))
        #Create grid
        y = np.linspace(-maxx+shiftx,maxx+shiftx,Nx)
        x = np.linspace(-maxy,maxy,Ny)
        X, Y = np.meshgrid(x,y)
        pos = np.empty(X.shape + (2,))
        pos[:, :, 0] = X; pos[:, :, 1] = Y
        res = [[0]*Ny for i in range(Nx)]
        first=False
        continue
    for i in range(Ny):
        res[j][i] = float(line.split()[i])
    j += 1
f.close()

biggest=1
for i in range(Nx):
    for j in range(Ny):
        if res[i][j]>biggest:
            biggest=res[i][j]
biggest=biggest/1
max_scale=1
min_scale=max_scale/1000
for i in range(Nx):
    for j in range(Ny):
        if res[i][j]==0:
            res[i][j]=min_scale
        else:
            res[i][j]=res[i][j]/biggest

print("imaging brightness profile...")
fig, ax = plt.subplots(figsize=(7+maxy-6, 6+maxx-6), constrained_layout=True)
CMmap=cm.get_cmap('CMRmap')
pcm = ax.pcolor(X, Y, res, norm=colors.LogNorm(vmin=min_scale, vmax=max_scale), cmap=CMmap)
fig.colorbar(pcm, ax=ax, extend='max')
plt.grid(color='grey', linestyle='--', linewidth=1, alpha=.7)
plt.xlabel(r'$\Theta_y[^\circ]$')
plt.ylabel(r'$\Theta_x[^\circ]$')
#plt.title(r"$\Theta_{obs} = 0^\circ$, $B_{rms}$ = 10^(-" + folder + r") gauss")
plt.show()
